#include <stdlib.h>
#include <stdio.h>
#define HASHSIZE 101

struct nlist { /*    */
    struct nlist *next; /*     */
    char *name; /*  */
    char *defn; /*    */
};

struct nlist *lookup(char *);
char *strdup(char *);

static struct nlist *hashtab[HASHSIZE]; /*    */

/* hash:      s */
unsigned hash(char *s)
{
    unsigned hashval;
    for (hashval = 0; *s != '\0'; s++)
        hashval = *s + 31 * hashval;
    return hashval % HASHSIZE;
}

/* lookup:  s  hashtab */
struct nlist *lookup(char *s)
{
    struct nlist *np;
    for (np = hashtab[hash(s)]; np != NULL; np = np->next)
        if (strcmp(s, np->name) == 0)
           return np; /*   */
    return NULL; /*    */
}

/* install:  (name, defn)  hashtab */
struct nlist *install(char *name, char *defn)
{
    struct nlist *np;
    unsigned hashval;
    if ((np = lookup(name)) == NULL) { /*    */
        np = (struct nlist *) malloc(sizeof(*np));
        if (np == NULL || (np->name = strdup(name)) == NULL)
           return NULL;
        hashval = hash(name);
        np->next = hashtab[hashval];
        hashtab[hashval] = np;
    } else /*    */
        free((void *) np->defn); /*     defn */
        if ((np->defn = strdup(defn)) == NULL)
           return NULL;
        return np;
}

/* printd:  n    */
void printd(int n)
{
    if (n < 0) {
        putchar('-');
        n = -n;
    }
    if (n / 10)
        printd(n / 10);
    putchar(n % 10 + '0');
}

int main() {
    
    printd(123);
    
    system("pause");
    return 0;
}
